// ignore_for_file: public_member_api_docs

import 'package:flutter/material.dart';

class DrawLead extends CustomPainter {
  const DrawLead({
    required this.leadstate,
  });

  final List<bool> leadstate;

  static const points = [
    Offset.zero,
    Offset(1 / 4, 1 / 4),
    Offset(0, 1),
    Offset(2 / 4, 1 / 4),
    Offset(3 / 4, 0),
    Offset(3 / 5, 3 / 5),
    Offset(7 / 10, 7 / 10),
    Offset(4 / 5, 4 / 5),
    Offset(1, 3 / 4),
    Offset(1, 1),
  ];

  static const sequence = [
    0,
    1,
    2,
    1,
    3,
    5,
    6,
    7,
    9,
    7,
    8,
    7,
    6,
    5,
    3,
    4,
    3,
    1,
    0,
  ];

  static const map = {
    0: 0,
    1: 2,
    2: 4,
    3: 9,
    4: 1,
    5: 3,
    6: 5,
    7: 6,
    8: 7,
    9: 8,
  };

  @override
  void paint(Canvas canvas, Size size) {
    final paint = Paint()
      ..color = Colors.black
      ..strokeWidth = 8;

    final on = Paint()..color = Colors.green;
    final off = Paint()..color = Colors.red;

    for (var i = 0; i < sequence.length - 1; i++) {
      final p1 = points[sequence[i]].scale(size.width, size.height);
      final p2 = points[sequence[i + 1]].scale(size.width, size.height);

      canvas.drawLine(p1, p2, paint);
    }

    for (var i = 0; i < leadstate.length; i++) {
      final p = points[map[i]!].scale(size.width, size.height);
      if (leadstate[i]) {
        canvas.drawCircle(p, 16, on);
      } else {
        canvas.drawCircle(p, 16, off);
      }
    }
  }

  @override
  bool shouldRepaint(CustomPainter oldDelegate) {
    var res = false;
    final old = (oldDelegate as DrawLead).leadstate;
    for (var i = 0; i < leadstate.length; i++) {
      if (old[i] != leadstate[i]) {
        res = true;
        break;
      }
    }
    return res;
  }
}
