// ignore_for_file: public_member_api_docs, avoid_positional_boolean_parameters

import 'package:copy_with_extension/copy_with_extension.dart';
import 'package:flutter/material.dart';
import 'package:flutter_mobx/flutter_mobx.dart';
import 'package:healthrian_visualization_support/'
    'healthrian_visualization_support.dart';

part 'tap_monitor.g.dart';

_$TapMonitorCWProxy get TapWearEcg =>
    TapMonitor(module: BLEManager().wearEcg12.module).copyWith;

_$TapMonitorCWProxy get TapCardioClick =>
    TapMonitor(module: BLEManager().cardioClick.module).copyWith;

_$TapMonitorCWProxy get TapWearT =>
    TapMonitor(module: BLEManager().wearCardioT.module).copyWith;

@CopyWith()
class TapMonitor extends StatelessWidget {
  const TapMonitor({
    required this.module,
    this.wrapperWidget,
    super.key,
  });

  final ModuleInterface module;

  final Widget Function(TapEvent?)? wrapperWidget;

  @override
  Widget build(BuildContext context) {
    final buffer = <TapEvent?>[];
    final f = wrapperWidget ??
        (TapEvent? value) {
          buffer.add(value);
          return Text('$buffer');
        };
    return Observer(
      key: UniqueKey(),
      builder: (context) {
        return StreamBuilder(
          stream: module.ble.streams.tap,
          builder: (context, snapshot) {
            return f(snapshot.data);
          },
        );
      },
    );
  }
}
