// ignore_for_file: public_member_api_docs

import 'package:flutter/material.dart';

class PdfViewerLandscape extends StatelessWidget {
  const PdfViewerLandscape({
    super.key,
  });

  @override
  Widget build(BuildContext context) {
    final screenWidth = MediaQuery.of(context).size.width;
    final screenHeight = MediaQuery.of(context).size.height;

    /// Fit a ratio of A4 paper
    final w = MediaQuery.of(context).size.width;
    final h = MediaQuery.of(context).size.height;
    final ratio = w / h;
    const ratioA4 = 1.41428;
    final scale = ratioA4 / ratio;
    final viewerWidth = ratio > ratioA4 ? w * scale : w;
    final viewerHeight = ratio > ratioA4 ? h : h / scale;

    final marginLR = (w - viewerWidth) / 2;
    final marginTB = (h - viewerHeight) / 2;

    return Card(
      margin: EdgeInsets.fromLTRB(
        marginLR,
        marginTB,
        marginLR,
        marginTB,
      ),
      shape: RoundedRectangleBorder(
        borderRadius: BorderRadius.circular(5),
      ),
      color: Colors.white,
      elevation: 0,
      child: Scaffold(
        backgroundColor: Colors.transparent,
        body: Center(
          child: Text(
            '$viewerWidth, $viewerHeight \n'
            '$screenWidth, $screenHeight\n'
            '$marginLR, $marginTB',
          ),
        ),
      ),
    );
  }
}
