// ignore_for_file: public_member_api_docs

import 'dart:math';

import 'package:flutter/material.dart';

class PdfViewerPortrait extends StatelessWidget {
  const PdfViewerPortrait({
    super.key,
  });

  @override
  Widget build(BuildContext context) {
    final screenWidth = MediaQuery.of(context).size.width;
    final screenHeight = MediaQuery.of(context).size.height;

    // TODO(chan150): 회전에 맞게 마진/사이즈 수정 필요

    /// Fit a ratio of A4 paper
    final w = MediaQuery.of(context).size.width;
    final h = MediaQuery.of(context).size.height;
    final ratio = h / w;
    const ratioA4 = 1.41428;
    final scale = ratio / ratioA4;
    final viewerWidth = ratio < ratioA4 ? w * scale : w;
    final viewerHeight = ratio < ratioA4 ? h : h / scale;

    final marginLR = (w - viewerWidth) / 2;
    final marginTB = (h - viewerHeight) / 2;

    return Card(
      margin: EdgeInsets.fromLTRB(
        // marginLR,
        // marginTB,
        // marginLR,
        // marginTB,
        100,
        100,
        100,
        100,
      ),
      shape: RoundedRectangleBorder(
        borderRadius: BorderRadius.circular(5),
      ),
      color: Colors.grey,
      elevation: 0,
      child: Scaffold(
        backgroundColor: Colors.transparent,
        body: Stack(
          children: [
            for (double i = 200; i < w; i += 200)
              Transform.rotate(
                angle: pi / 2,
                child: Container(
                  width: i,
                  height: i * ratioA4,
                  decoration: BoxDecoration(
                    border: Border.all(),
                  ),
                ),
              ),
            Text(
              '$viewerWidth, $viewerHeight \n'
              '$screenWidth, $screenHeight\n'
              '$marginLR, $marginTB',
            ),
          ],
        ),
      ),
    );
  }
}
